AC自动机+dp(CodeForces - 86C )

"Multidimensional spaces are completely out of style these days, unlike genetics problems" — thought physicist Woll and changed his subject of study to bioinformatics. Analysing results of sequencing he faced the following problem concerning DNA sequences. We will further think of a DNA sequence as an arbitrary string of uppercase letters "A", "C", "G" and "T" (of course, this is a simplified interpretation).

Let w be a long DNA sequence and s1, s2, ..., sm — collection of short DNA sequences. Let us say that the collection filters w iff w can be covered with the sequences from the collection. Certainly, substrings corresponding to the different positions of the string may intersect or even cover each other. More formally: denote by |w| the length of w, let symbols of w be numbered from 1 to |w|. Then for each position i in w there exist pair of indices l, r (1 ≤ l ≤ i ≤ r ≤ |w|) such that the substring w[l ... r] equals one of the elements s1, s2, ..., sm of the collection.

Woll wants to calculate the number of DNA sequences of a given length filtered by a given collection, but he doesn‘t know how to deal with it. Help him! Your task is to find the number of different DNA sequences of length n filtered by the collection {si}.

Answer may appear very large, so output it modulo 1000000009.

Input

First line contains two integer numbers n and m (1 ≤ n ≤ 1000, 1 ≤ m ≤ 10) — the length of the string and the number of sequences in the collection correspondently.

Next m lines contain the collection sequences si, one per line. Each si is a nonempty string of length not greater than 10. All the strings consist of uppercase letters "A", "C", "G", "T". The collection may contain identical strings.

Output

Output should contain a single integer — the number of strings filtered by the collection modulo 1000000009 (109 + 9).

Example

Input

2 1A

Output

1

Input

6 2CATTACT

Output

2

Note

In the first sample, a string has to be filtered by "A". Clearly, there is only one such string: "AA".

In the second sample, there exist exactly two different strings satisfying the condition (see the pictures below).

题意:简单说一下吧,就是让你构造一个长度为n的字符串,在总共m个子串中选择,构造的字符串中的每一个字符都需要有子串提供,求构成的方案。

题解:我写这题也是煞费苦心啊,写了两个晚上,重构了n次,ac自动机掌握的不扎实啊。

讲一下我的思考过程吧,也就是我抄题解的过程。

首先,由于串的匹配,并且有多个串,就很容易(??)想到ac自动机这个算法。

然后既然是dp专题里的,就是用dp去做(formally这些数方案的差不多都是dp。。)

我们用区间dp的套路设 dp[i][j]表示匹配到i这个位置,选j的方案。发现并不能成功,于是我们再把j改成ac自动机上的节点,

于是方程就变成了dp[i][j]表示匹配到串i,到达ac自动机节点j的方案数。

然后会发现这样并不是最优解,因为串和串之间是有可能重叠的。

我们再设dp[i][j][k]表示。。。后面有k个剩余的答案。剩余表示这个串的后k个还没有匹配,接下来有可能有串匹配

于是我们非常容易推导出dp方程

dp[i][j][k]->dp[i+1][j][0]剩余k->0匹配上了。

dp[i][j][k]->dp[i+1][j][k+1]没有匹配上。

于是答案就是sigma dp[n][所有ac自动机的节点][0]

边界dp[0][0][0]=1;

于是我们就在o(100nm)的时间内解决了这个问题。

放上臭但是不长的代码。

#include<bits/stdc++.h>
#define int long long
#define N 1100
using namespace std;
const int mod =1e9+9;
int f[N][N][11],n,m,ch[N][4],val[N],fail[N],sz,root=0,mx=0;
void add(int &x,int y)
{
	x+=y;
	if(x<0) x+=mod;
	while(x>=mod) x-=mod;
}

int idx(char c)
{
	if(c==‘A‘) return 0;
	if(c==‘C‘) return 1;
	return c==‘T‘?3:2;
}

int newnode()
{
	for(int i=0;i<4;i++) ch[sz][i]=0;
	val[sz++]=0;return sz-1;
}

void insert(char *s,int len)
{
	int u=0;
	for(int i=0;i<len;i++)
	{
		int v=idx(s[i]);
		if(ch[u][v]==0) ch[u][v]=newnode();
		u=ch[u][v];
	}
	val[u]=max(val[u],len);
}
void build()
{
	queue<int> q;
	for(int i=0;i<4;i++)
	{
		if(ch[root][i]==0) ch[root][i]=root;
		else fail[ch[root][i]]=root,q.push(ch[root][i]);
	}
	while(!q.empty())
	{
		int u=q.front();q.pop();
		for(int i=0;i<4;i++)
		{
			int &v=ch[u][i];
			if(v==0) v=ch[fail[u]][i];
			else fail[v]=ch[fail[u]][i],q.push(v),val[v]=max(val[v],val[fail[v]]);
		}
	}

}

void dp()
{
	f[0][0][0]=1;
	for(int i=0;i<n;i++)
		for(int j=0;j<=sz;j++)
			for(int k=0,v;k<=mx;k++)if(v=f[i][j][k])
			{
				//printf ( "dp[%d][%d][%d] = %d\n" , i , j , k , f[i][j][k] );
				for(int p=0;p<4;p++)
				{
					int now=ch[j][p];
					if(val[now]>k) add(f[i+1][now][0],v);
					else if(k<mx) add(f[i+1][now][k+1],v);
				}
			}

	int ans=0;
	for(int i=0;i<=sz;i++) add(ans,f[n][i][0]);
	cout<<ans<<"\n";
//	for(int i=1;i<=sz;i++) cout<<val[i]<<"\n";
}
char str[200];
main()
{
	//freopen("1.txt","w",stdout);
	root=newnode();
	cin>>n>>m;
	for(int i=1,len;i<=m;i++)
		scanf("%s",str),len=strlen(str),mx=max(mx,len),insert(str,len);
	build();
	dp();
	return 0;
}
时间: 2024-10-29 19:11:48

AC自动机+dp(CodeForces - 86C )的相关文章

HDU3341 Lost&#39;s revenge(AC自动机+DP)

题目是给一个DNA重新排列使其包含最多的数论基因. 考虑到内存大概就只能这么表示状态: dp[i][A][C][G][T],表示包含各碱基个数为ACGT且当前后缀状态为自动机第i的结点的字符串最多的数论基因数 其中ACGT可以hash成一个整数(a*C*G*T+c*G*T+g*T+T),这样用二维数组就行了,而第二维最多也就11*11*11*11个. 接下来转移依然是我为人人型,我是丢进一个队列,用队列来更新状态的值. 这题果然挺卡常数的,只好手写队列,最后4500msAC,还是差点超时,代码也

poj 1625 Censored!(AC自动机+DP+高精度)

题目链接:poj 1625 Censored! 题目大意:给定N,M,K,然后给定一个N字符的字符集和,现在要用这些字符组成一个长度为M的字符串,要求不包 括K个子字符串. 解题思路:AC自动机+DP+高精度.这题恶心的要死,给定的不能匹配字符串里面有负数的字符情况,也算是涨姿势 了,对应每个字符固定偏移128单位. #include <cstdio> #include <cstring> #include <queue> #include <vector>

HDU 2296 Ring AC自动机 + DP

题意:给你n个模式串,每个模式串有一个得分,让你构造出一个长度为N之内且分数最高的文本串;输出字典序列最小的. 解题思路:  AC自动机 + DP , 不过要输出字典序列最小,多开一个 一个三维字符串来辅助二维DP(新思路) , DP[i][j] ,表示到i位置状态为j的最大得分. 解题代码: 1 // File Name: temp.cpp 2 // Author: darkdream 3 // Created Time: 2014年09月11日 星期四 15时18分4秒 4 5 #inclu

HDU2296——Ring(AC自动机+DP)

题意:输入N代表字符串长度,输入M代表喜欢的词语的个数,接下来是M个词语,然后是M个词语每个的价值.求字符串的最大价值.每个单词的价值就是单价*出现次数.单词可以重叠.如果不止一个答案,选择字典序最小的. 题解:AC自动机+dp.dp[i][j]表示在字符串长度i,在自动机的第j个状态.因为要字典序最小,所以转移时要保持字典序最小. 想了各种转移姿势 最后还是查了题解 发现可以直接记录前缀转移…… #include <bits/stdc++.h> using namespace std; co

hdu 2296 aC自动机+dp(得到价值最大的字符串)

Ring Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3180    Accepted Submission(s): 1033 Problem Description For the hope of a forever love, Steven is planning to send a ring to Jane with a rom

hdu 2457 AC自动机+dp

DNA repair Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2004    Accepted Submission(s): 1085 Problem Description Biologists finally invent techniques of repairing DNA that contains segments c

POJ1625 Censored!(AC自动机+DP)

题目问长度m不包含一些不文明单词的字符串有多少个. 依然是水水的AC自动机+DP..做完后发现居然和POJ2778是一道题,回过头来看都水水的... dp[i][j]表示长度i(在自动机转移i步)且后缀状态为自动机第j个结点的合法字符串数 dp[0][0]=1 转移转移... 注意要用高精度,因为答案最多5050. 还有就是要用unsigned char,题目的输入居然有拓展的ASCII码,编码128-255. 1 #include<cstdio> 2 #include<cstring&

HDU2296 Ring(AC自动机+DP)

题目是给几个带有价值的单词.而一个字符串的价值是 各单词在它里面出现次数*单词价值 的和,问长度不超过n的最大价值的字符串是什么? 依然是入门的AC自动机+DP题..不一样的是这题要输出具体方案,加个字符数组记录每个状态最优情况的字符串即可. 另外题目字典序是先考虑长度再考虑每一位单词:特别要注意,有一个非常坑的地方看了Disscus才知道——单词A包含单词B,那么只计算单词A不计算单词B. dp[i][j]表示长度i(自动机上转移k步)后缀状态是自动机第j个结点的字符串的最大价值 dp[0][

HDU2457 DNA repair(AC自动机+DP)

题目一串DNA最少需要修改几个基因使其不包含一些致病DNA片段. 这道题应该是AC自动机+DP的入门题了,有POJ2778基础不难写出来. dp[i][j]表示原DNA前i位(在AC自动机上转移i步)且后缀状态为AC自动机结点j的最少需要修改的基因数 转移我为人人型,从dp[i][j]向ATCG四个方向转移到dp[i+1][j'],如果结点被标记包含致病基因就不能转移. 1 #include<cstdio> 2 #include<cstring> 3 #include<que

UVA 1399 - Puzzle(AC自动机+DP)

UVA 1399 - Puzzle 题目链接 题意:给定一些字符串,求一个最长的不在包含这些子串的字符串,如果可以无限长输出No 思路:建ACM自动机,把不可走结点标记构造出来,然后在这个状态图上进行dp找出最长路径即可,至于无限长的情况,只要在dp前进行一次dfs判有没有环即可 代码: #include <cstdio> #include <cstring> #include <string> #include <algorithm> #include &